#include <iostream>
#include <vector>

class Person {
protected:
    double m_weight;

public:
    Person(double weight)
    {
        m_weight = weight;
    };

    double weight() { return m_weight; };
    virtual double exercise(double exerciseTime) { return 0.0; };
};

class RunningPerson : public Person {

    using Person::Person;
public:
    double exercise(double exerciseTime)
    {
        double calory = 9 * m_weight * exerciseTime * 1.05 / 60;
        m_weight = m_weight - calory / 7200;

        return m_weight;
    };
};

class WalkingPerson : public Person {

    using Person::Person;
public:
    double exercise(double exerciseTime)
    {
        double calory = 3 * m_weight * exerciseTime * 1.05 / 60;
        m_weight = m_weight - calory / 7200;
        return m_weight;
    };
};

class CyclingPerson : public Person {

    using Person::Person;
public:
    double exercise(double exerciseTime)
    {
        double calory = 5 * m_weight * exerciseTime * 1.05 / 60;
        m_weight = m_weight - calory / 7200;
        return m_weight;
    };
};

int main()
{
    std::string exerciseType{};
    double weight{};
    int height{};
    double exerciseTime{};
    int count{};

    std::cout << "running/walking/cycling ̒ŁAȂ̉^̃^Cv͂ĂB" << std::endl;
    std::cin >> exerciseType;

    if ((exerciseType != "running") and (exerciseType != "walking") and (exerciseType != "cycling")) {
        std::cout << "running /walking /cycling ̒I΂Ȃ̂ŏI܂B" << std::endl;
        return 0;
    }
    
    std::cout << "̏dikgj͂ĂB" << std::endl;
    std::cin >> weight;

    std::unique_ptr<Person> person;

    if (exerciseType == "running") {
        person = std::make_unique<RunningPerson>(weight);
    }
    else if (exerciseType == "walking") {
        person = std::make_unique<WalkingPerson>(weight);
    }
    else if (exerciseType == "cycling") {
        person = std::make_unique<CyclingPerson>(weight);
    }

    std::cout << "^ԁij͂ĂB" << std::endl;
    std::cin >> exerciseTime;

    std::cout << "^邩A͂ĂB" << std::endl;
    std::cin >> count;

    std::vector<double> weightList;
    for (int i = 0; i < count; i++) {
        double bmi = person->exercise(exerciseTime);
        weightList.push_back(bmi);
    }

    std::cout << "̏d̑J: ";
    try {
        std::cout << weightList.at(0) << ", " << weightList.at(weightList.size() - 1);
    }
    catch (...) {
        std::cout << "G[܂B";
        return 0;
    }

    return 0;
}
